/**
 * @file  PropGeneral.h
 *
 * @brief Declaration of CPropGeneral class
 */
// RCS ID line follows -- this is updated by CVS
// $Id: PropGeneral.h 4381 2007-07-25 09:27:20Z kimmov $

#if !defined(AFX_PROPGENERAL_H__30AD07B0_E420_11D1_BBC5_00A024706EDC__INCLUDED_)
#define AFX_PROPGENERAL_H__30AD07B0_E420_11D1_BBC5_00A024706EDC__INCLUDED_

#include "IOptionsPanel.h"

class COptionsMgr;

/////////////////////////////////////////////////////////////////////////////
// CPropGeneral dialog

/**
 * @brief Class for General options -propertypage.
 */
class CPropGeneral : public CPropertyPage, public IOptionsPanel
{
// Construction
public:
	CPropGeneral(COptionsMgr *optionsMgr);
	~CPropGeneral();

// Implement IOptionsPanel
	virtual void ReadOptions();
	virtual void WriteOptions();

// Dialog Data
	//{{AFX_DATA(CPropGeneral)
	enum { IDD = IDD_PROPPAGE_LARGE };
	bool  m_bScroll;
	bool  m_bDisableSplash;
	bool  m_bSingleInstance;
	bool  m_bVerifyPaths;
	bool  m_bCloseWindowWithEsc;
  bool  m_bAskMultiWindowClose;
	bool	m_bMultipleFileCmp;
	bool	m_bMultipleDirCmp;
	int		m_nAutoCompleteSource;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPropGeneral)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual BOOL OnInitDialog();

	// Generated message map functions
	//{{AFX_MSG(CPropGeneral)
	afx_msg void OnResetAllMessageBoxes();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	COptionsMgr *m_pOptionsMgr;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROPGENERAL_H__30AD07B0_E420_11D1_BBC5_00A024706EDC__INCLUDED_)

